#!/usr/bin/perl
use strict;
use warnings;
use Bio::TreeIO;
use Bio::Tree::TreeFunctionsI;
my $treefile="1644tax_ancestral_state.newick";
open (IN, $treefile) or die "can't open the file $treefile:$!";
  while (my $content=<IN>) {
	   chomp $content;
	   my $n=1;
	   #[&CI={29.636846,43.269537},ancstate={36.453192}]:0.002689
	    while( $content=~s/\)\[\&CI=\{([0-9-_\.]+),([0-9\._]+)\},ancstate=\{([0-9-_\.]+)\}\]\:([0-9-_\.]+)/\)I$n\:$4\[CI=$1to$2at$3\]/){$n++;}#print "$treefile\tI$n\n";
		my $outputs= "${treefile}.md";
        open (OUTPUT,">>", $outputs) or die "Can't write the file $outputs: $!";
               #  )[&CI={-10.534146,90.607626},ancstate={40.03674}];
	       $content=~s/(.*)\[\&CI=\{([0-9-_\.]+),([0-9-_\.]+)\},ancstate=\{([0-9-_\.]+)\}\];/$1:0\[CI=$2to$3at$4\];/i;
        print OUTPUT "$content\n";
	    close OUTPUT;
  }
  close IN;


my $tree="${treefile}.md";
my $treein = new Bio::TreeIO(-file => "$tree", -format => 'newick',-internal_node_id => 'bootstrap');
while (my $tree = $treein->next_tree()) {
        my @nodes = $tree->get_nodes;
		  my $i=0;
          foreach my $node ( @nodes ) {
	       unless ($node->is_Leaf) {    
		     
			  my $internode_id=$node->bootstrap;
			  my $internode_branch_len=$node->branch_length;
			  #print "internode$i\t$internode_id\t$internode_branch_len\n";
			  my @child_names;
		     foreach my $child ( $node->get_all_Descendents ) {my $child_name= $child->id;if ( defined $child_name){push @child_names, $child_name if $child_name=~m/\w+/;}}
		     my $child_no=scalar @child_names;
		     my @sorted_child_names=sort { $a cmp $b }@child_names;
		     my $subtaxa=join( ",", @sorted_child_names);
			 if ($child_no>=2) {
				  $i++;
				 #  print "internode$i\t$internode_id\n";
				  next unless $internode_id=~m/(CI=[0-9-_\.]++to[0-9-_\.]+)at([\d+\.]+)/gi;
				    print "internode$i\t$child_no\t$internode_branch_len\t$2\t$1\n";
				 	 my $output = "Ancestral_state4internodes.txt";
                      open (FILEIN,">>", $output) or die "can't write the file $output:$!";
                      print FILEIN "internode$i\t$child_no\t$subtaxa\t$internode_branch_len\t$2\t$1\n";
		              close FILEIN;
			   }
		   }
	
		 }
	
	 
}

my @files;
push @files,$tree;
unlink @files;