#!/usr/bin/perl
use strict;
use warnings;
my %time;
my $treefile="1644_timetree_times.txt";
open (IN, $treefile) or die "can't open the file $treefile:$!";
  while (my $content=<IN>) {
	   chomp $content;
	   my @colms=split(/\t+/,$content);
	   @{$time{$colms[2]}}=($colms[3],$colms[1]);
  }
  close IN;

my %rate;
my $treefile2="All_root2internode.txt";
open (IN, $treefile2) or die "can't open the file $treefile2:$!";
  while (my $content=<IN>) {
	   chomp $content;
	   my @colms=split(/\t+/,$content);
	   @{$rate{$colms[2]}}=($colms[3],$colms[1]);
  }
  close IN;


my %genome;
my $treefile3="Ancestral_state4internodes.txt";
open (IN, $treefile3) or die "can't open the file $treefile3:$!";
  while (my $content=<IN>) {
	   chomp $content;
	   my @colms=split(/\t+/,$content);
	   @{$genome{$colms[2]}}=($colms[4],$colms[5],$colms[1]);
  }
  close IN;

 my $output = "Summary_time_rate_anc_genome_size_4_intenrodes.txt";
 open (FILEIN,">>", $output) or die "can't write the file $output:$!";
 print FILEIN "internode_subtaxa\tanc_genome_mean\tanc_genome_content_CI\trelative_time\tintenrode2root_distance\n";

foreach my $key  (sort {@{$genome{$b}}[2] <=> @{$genome{$a}}[2]} keys %genome) {

        
          print FILEIN "$key\t@{$genome{$key}}[0]\t@{$genome{$key}}[1]\t@{$time{$key}}[0]\t@{$rate{$key}}[0]\n";
		  
 }
close FILEIN;