#!/usr/bin/perl
use strict;
use warnings;
use Bio::TreeIO;
use Bio::Tree::TreeFunctionsI;

my %root_taxa=('Rozella_allomycis' => 1, 'Saccharomyces_cerevisiae' => 1);
my $treefile="1644taxa_290genes_bb_1_root.tre";
my $treein = new Bio::TreeIO(-file => "$treefile", -format => 'newick',-internal_node_id => 'bootstrap');
while (my $tree = $treein->next_tree()) {
       # print "$key\t@{$hash{$key}}\n";
		  my @root_nodes;
		  my  @leaf_names;
	      my @nodes = $tree->get_nodes;
          foreach my $node ( @nodes ) {
		     if (defined $node->is_Leaf) {
		       my $leaf_name = $node->id;
		       if (defined $leaf_name && exists $root_taxa{$leaf_name}) { push @root_nodes, $node;push @leaf_names, $leaf_name;}
		     }
		  }	
	      my $root_lca = $tree->get_lca(-nodes => \@root_nodes); ## Get the lowest common ancestor for a set of Nodes ##
	      my $root_lca_internode_id=$root_lca->bootstrap;
		  my $root_lca_internode_branch_len=$root_lca->branch_length;


		  my $i=0;
          foreach my $node ( @nodes ) {
	       unless ($node->is_Leaf) {    
		     my @child_names;
		     foreach my $child ( $node->get_all_Descendents ) {my $child_name= $child->id;if ( defined $child_name){push @child_names, $child_name if $child_name=~m/\w+/;}}
		     my $child_no=scalar @child_names;
		     my @sorted_child_names=sort { $a cmp $b }@child_names;
		     my $subtaxa=join( ",", @sorted_child_names);
			 if ($child_no>=2) {
				  $i++;
				 my $distance = $tree->distance( -nodes => [ $root_lca, $node]) ;
				 print "internode$i\t$child_no\t$distance\n";
				 	 my $output = "All_root2internode.txt";
                      open (FILEIN,">>", $output) or die "can't write the file $output:$!";
                      print FILEIN "internode$i\t$child_no\t$subtaxa\t$distance\n";
		              close FILEIN;
			   }
		   }
	
		 }
	
	 
}
		
 
